/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2009 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
#define __STDC_CONSTANT_MACROS  1
#include "cfg.hpp"
#include <ctime>
#include <sys/types.h>
#include <sys/stat.h>

//! cfg̃o[W
extern char const cfg_version[] = "1.5.0";

/*!
 *  \brief  vOt@C(cfg or cfg.exe)̃^CX^v擾B
 *  \return ^CX^v64rbglƂĕԂB
 *
 *  ԋpľ`
 *
 *  YYYYMMDDhhmmss
 *
 *  ƂȂBYYYY͔NAMM͌ADD͓Ahh͎Amm͕Ass͕b
 *
 *  \note   t@C main ̈ argv[0] gĂBPATH ͌Ȃ̂Œ!
 *  \note   ̊֐ stat ֐ɈˑĂ邽߈ڐAɖ肪B
 */
std::tr1::int64_t cfg_timestamp()
{
  std::tr1::int64_t result;

  try
  {
    std::string program_name = toppers::get_global< std::string >( "argv0" );

    struct stat sb;
    stat( program_name.c_str(), &sb );
    struct tm t = *localtime( &sb.st_mtime );
    result = ( t.tm_year + 1900 ) * INT64_C( 10000000000 ) + ( t.tm_mon + 1 ) * INT64_C( 100000000 ) + t.tm_mday * 1000000
      + t.tm_hour * 10000 + t.tm_min * 100 + t.tm_sec;
  }
  catch ( ... )
  {
    result = -1;
  }
  return result;
}
